/*
 *	main.c
 */
#include "app.h"

#define FPS		15
#define SEC(s)		(FPS * (s))
#define period()	{ pceLCDTrans(); yield(); }

char vbuff[DISP_X * DISP_Y];	/* zVRAM */
USBCOMINFO uci = { "vsjken" };	/* USBCOMVOl` */

char* hand_tbl[3] = { " [ ", "傫", " ρ[ " };
int my_hand;	/* ̎ */
int peer_hand;	/* G̎ */

int my_win;	/*  */
int peer_win;	/* 肪 */

int
main()
{
	int i;

	/* B */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceUSBCOMSetup(&uci);
	pceAppSetProcPeriod(1000 / FPS);
	pceLCDDispStart();

	for(;;) {
		/* ̎Iт܂B */
		for(;;) {
			memset(vbuff, 0, sizeof vbuff);
			if(pcePadGet() & TRG_A) break;
			if(pcePadGet() & TRG_LF) my_hand = (my_hand + 2) % 3;
			if(pcePadGet() & TRG_RI) my_hand = (my_hand + 1) % 3;
			pceFontSetPos(0, 0);
			pceFontPutStr("̎IłˁI");
			pceFontSetPos(49, 39);
			pceFontPutStr(hand_tbl[my_hand]);
			period();
		}

		/* ̎𑗐M܂B */
		memset(vbuff, 0, sizeof vbuff);
		pceFontSetPos(0, 0);
		pceFontPutStr("̎𑗐M...");
		while(pceUSBCOMGetStat() & (UCS_TXWAIT | UCS_TXING)) period();
		pceUSBCOMStartTx((unsigned char*)&my_hand, sizeof my_hand);

		/* ̎M܂B */
		memset(vbuff, 0, sizeof vbuff);
		pceFontSetPos(0, 0);
		pceFontPutStr("̎M...");
		while(pceUSBCOMGetStat() & (UCS_RXWAIT | UCS_RXING)) period();
		pceUSBCOMStartRx((unsigned char*)&peer_hand, sizeof peer_hand);
		while(!(pceUSBCOMGetStat() & UCS_RXDONE)) period();

		/* sB */
		memset(vbuff, 0, sizeof vbuff);
		pceFontSetPos(0, 0);
		pceFontPutStr("");
		pceFontSetPos(26, 20);
		pceFontPrintf("̎:%s", hand_tbl[my_hand]);
		pceFontSetPos(26, 30);
		pceFontPrintf("̎:%s", hand_tbl[peer_hand]);
		pceFontSetPos(44, 50);
		if((my_hand + 1) % 3 == peer_hand) {
			pceFontPutStr(" I ");
			my_win++;
		} else if((peer_hand + 1) % 3 == my_hand) {
			pceFontPutStr(" ܂` ");
			peer_win++;
		} else {
			pceFontPutStr("Ђ킯");
		}
		pceFontSetPos(46, 60);
		pceFontPrintf("%d %ds", my_win, peer_win);
		for(i = 0; i < SEC(2); i++) period();

		/* ǂ炩R炨܂B */
		if(my_win == 3 || peer_win == 3) break;
	}

	/* ܂B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetPos(44, 39);
	pceFontPutStr("܂");
	for(i = 0; i < SEC(2); i++) period();

	/* IB */
	pceUSBCOMStop();

	return 0;
}
